% maennlich(Mann)
maennlich(paul).
maennlich(fritz).
maennlich(steffen).
maennlich(robert).

% weiblich(Frau)
weiblich(karin).
weiblich(maria).
weiblich(sina).
weiblich(lisa).

% vater(Vater, Kind)
vater(steffen, paul).
vater(fritz, karin).
vater(steffen, lisa).
vater(paul, maria).

% mutter(Mutter, Kind)
mutter(karin, maria).
mutter(sina, paul).
mutter(maria, robert).

% elternteil(Elter, Kind)
elternteil(Elter, Kind):- 
  vater(Elter, Kind).
elternteil(Elter, Kind):- 
  mutter(Elter, Kind).

% sohn(Sohn, Elter)
sohn(Kind, Elter):-
  maennlich(Kind),
  elternteil(Elter, Kind).
                     
% tochter(Tochter, Elter)
tochter(Kind, Elter):- 
  weiblich(Kind), 
  elternteil(Elter, Kind).

% grossmutter(Oma, Enkel)
grossmutter(Oma, Enkel):-
  mutter(Oma, Elter),
  elternteil(Elter, Enkel).

% bruder(X, Y)
bruder(X, Y):- 
  maennlich(X),
  elternteil(E, X),
  elternteil(E, Y),
  X \== Y.
                
% vorfahr(X, Y)
vorfahr(X, Y):- 
  elternteil(X, Y).
vorfahr(X, Y):- 
  elternteil(X, Z),
  vorfahr(Z, Y).


